#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>

#include "serial.h"
#include "tlc5947.h"
#include "matrix.h"
#include "spi.h"

#define	NB_DRIVERS		3
#define MAX_VALEUR		64
#define ON 128
	
int groupes[NB_DRIVERS*DLED_CHANNELS];

unsigned char OFF[]={0,0,0,0,0,0,0,0};
 
//exemple du B pour l'ancien codage
/*unsigned char B[]={
  0,0,ON,0,0,0,0,0,
  0,0,ON,0,0,0,0,0,
  0,0,ON,0,0,0,0,0,
  0,0,ON,ON,ON,ON,0,0,
  0,0,ON,0,0,ON,0,0,
  0,0,ON,0,0,ON,0,0,
  0,0,ON,ON,ON,ON,0,0,
  0,0,0,0,0,0,0,0,
  };*/
//Nouveau codage du B
unsigned char B[]={32, 32, 32, 60, 36, 36, 60, 0};

//Nouveau codage du J  
unsigned char J[]={0, 28, 8, 8, 8, 40, 16, 0};

//Nouveau codage du N
unsigned char N[]={0, 68, 100, 84, 76, 68, 0, 0};

//Nouveau codage du O
unsigned char O[]={0, 0, 60, 36, 36, 60, 0, 0};

//Nouveau codage du R
unsigned char R[]={0, 60, 36, 60, 48, 40, 36, 0};

//Nouveau codage du U
unsigned char U[]={0, 0, 36, 36, 36, 36, 24, 0};

/*Attention, les autres caractères n'ayant pas été recodés, leur cas dans le switch a été commenté*/

int main(void)
{
  
  /*****Tests*****/
  init_LED_Drivers(NB_DRIVERS); // requis pour configuration des 2 tlc5947
  while(1){
    
    set_LED_Drivers(groupes,NB_DRIVERS); // requis pour configuration des 2 tlc5947
    spi_init(0); // initialisation de la communication SPI
    matrix_set(groupes, OFF);
    uint8_t received = spi_exch(0xFF); // si OxFF le périphérique n'est pas disponible
    
    /*Affichage du caractère reçu*/
    /*Attention, les autres caractères n'ayant pas été recodés, leur cas dans le switch a été commenté*/
    switch(received) {
      //case 'A': //A
      //matrix_set(groupes, A);
      //break;
      case 'B': //B
      matrix_set(groupes, B);
      break;
      /*case 'C': //C
      matrix_set(groupes, C);
      break;
      case 'D': //D
      matrix_set(groupes, D);
      break;
      case 'E': //E
      matrix_set(groupes, E);
      break;
      case 'F': //F
      matrix_set(groupes, F);
      break;
      case 'G': //G
      matrix_set(groupes, G);
      break;
      case 'H': //H
      matrix_set(groupes, H);
      break;
      case 'I': //I
      matrix_set(groupes, I);
      break;*/
      case 'J': //J
      matrix_set(groupes, J);
      break;
      /*case 'K': //K
      matrix_set(groupes, K);
      break;
      case 'L': //L
      matrix_set(groupes, L);
      break;
      case 'M': //M
      matrix_set(groupes, M);
      break;*/
      case 'N': //N
      matrix_set(groupes, N);
      break;
      case 'O': //O
      matrix_set(groupes, O);
      break;
      /*case 'P': //P
      matrix_set(groupes, P);
      break;
      case 'Q': //Q
      matrix_set(groupes, Q);
      break;*/
      case 'R': //R
      matrix_set(groupes, R);
      break;
      /*case 'S': //S
      matrix_set(groupes, S);
      break;
      case 'T': //T
      matrix_set(groupes, T);
      break;*/
      case 'U': //U
      matrix_set(groupes, U);
      break;
      /*case 'V': //V
      matrix_set(groupes, V);
      break;
      case 'W': //W
      matrix_set(groupes, W);
      break;
      case 'X': //X
      matrix_set(groupes, X);
      break;
      case 'Y': //Y
      matrix_set(groupes, Y);
      break;
      case 'Z': //Z
      matrix_set(groupes, Z);
      break;*/
      //case 0xFF: //Z
      // rien, cela signifie que le maitre demandait si l'esclave était à l'écoute
      //break;
    }      
  }
  

return 0;
}
