/************************
*  SPI minimal library  *
************************/

#include <stdint.h>
#include <avr/io.h>
#include <avr/interrupt.h>  

#include "spi.h"

// Initialisation of SPI bus
void spi_init(unsigned char master)
{
if(master){
  SPI_DDR |= (1<<SPI_MOSI)|(1<<SPI_SCK)|(1<<SPI_SS);
  SPI_DDR &= ~(1<<SPI_MISO);
  }
else{
  SPI_DDR |= (1<<SPI_MISO);
  SPI_DDR &= (~(1<<SPI_MOSI))&(~(1<<SPI_SCK))&(~(1<<SPI_SS));
  }
if(master) SPCR |= (1<<MSTR);
SPCR |= (1<<SPE);
}

// Permet de recevoir et d'envoyer un octet sur le bus SPI
uint8_t spi_exch(uint8_t output)
{
  SPDR = output; // envoie d'un octet fictif (nécessaire pour la lecture suivante)
  while(!(SPSR & (1<<SPIF))); // récupération des bits jusqu'à la récupération de l'octet complet
  return SPDR; // récupération de l'octet reçu
}
